
module grace_prim_bitlog;

import grace_def;
import grace_cstk;
import grace_dict;
import grace_eval;
import grace_reader;
import grace_prim;

void reg_prim()
{
  dict_addnf("not",&p_bit_not,["int"]      ,["int"]);
  dict_addnf("and",&p_bit_and,["int","int"],["int"]);
  dict_addnf("or" ,&p_bit_or ,["int","int"],["int"]);
  dict_addnf("xor",&p_bit_xor,["int","int"],["int"]);
  dict_addnf("not",&p_log_not,["log"]      ,["log"]);
  dict_addnf("and",&p_log_and,["log","log"],["log"]);
  dict_addnf("or" ,&p_log_or ,["log","log"],["log"]);
  dict_addnf("xor",&p_log_xor,["log","log"],["log"]);
}

static this()
{
  reg_prims~=&reg_prim;
}

void p_bit_not()
{
  cell c=dpop();
  dpush(int2cell((cast(int)(-1))^cell2int(c)));
}

void p_bit_and()
{
  cell c=dpop();
  dpush(int2cell(cell2int(dpop())&cell2int(c)));
}

void p_bit_or()
{
  cell c=dpop();
  dpush(int2cell(cell2int(dpop())|cell2int(c)));
}

void p_bit_xor()
{
  cell c=dpop();
  dpush(int2cell(cell2int(dpop())^cell2int(c)));
}

void p_log_not()
{
  cell c=dpop();
  dpush(log2cell(!cell2log(c)));
}

void p_log_and()
{
  cell c=dpop();
  dpush(log2cell(cell2log(dpop())&&cell2log(c)));
}

void p_log_or()
{
  cell c=dpop();
  dpush(log2cell(cell2log(dpop())||cell2log(c)));
}

void p_log_xor()
{
  cell c=dpop();
  dpush(log2cell((cell2log(dpop())!=0)^(cell2log(c))!=0));
}

