
module grace_prim_list;

import grace_def;
import grace_cstk;
import grace_dict;
import grace_eval;
import grace_reader;
import grace_prim;

void reg_prim()
{
  // list functions
  dict_addnf("cat"    ,&p_cat    ,["lst","lst"],      ["lst"]);
  dict_addnf("head"   ,&p_head   ,["lst"]      ,      [ "*" ]);
  dict_addnf("tail"   ,&p_tail   ,["lst"]      ,      ["lst"]);
  dict_addnf("cons"   ,&p_cons   ,[ "*" ,"lst"],      ["lst"]);
  dict_addnf("split"  ,&p_split  ,["lst"]      ,[ "*" ,"lst"]);
  dict_addnf("scons"  ,&p_scons  ,["lst", "*" ],      ["lst"]); // swap cons
  dict_addnf("splits" ,&p_splits ,["lst"]      ,      [ "*" ]); // split swap
  dict_addnf("length" ,&p_length ,["lst"]      ,      ["int"]);
  dict_addnf("reverse",&p_reverse,["lst"]      ,      ["lst"]);
  dict_addnf("getat"  ,&p_getat  ,["lst","int"],      [ "*" ]);
  dict_addnf("setat"  ,&p_setat  ,["lst","*","int"],  ["lst"]);
}

static this()
{
  reg_prims~=&reg_prim;
}

// --------------------
// ----- lists

void p_getat()
{
  int idx=dpop_int();
  cell[] lst=dpop_lst();
  dpush(lst[idx]);
}

void p_setat()
{
  int idx=dpop_int();
  cell dat=dpop();
  cell[] lst=dpop_lst();
  lst[idx]=dat;
  dpush_lst(lst);
}

void p_cat()
{
  cell[] l0=cell2lst(dpop());
  cell[] l1=cell2lst(dpop());
  dpush(lst2cell(l1~l0));
}

void p_head()
{
  cell[] l=cell2lst(dpop());
  if (l.length>0)
    dpush(l[0]);
}

void p_tail()
{
  cell[] l=cell2lst(dpop());
  if (l.length>1)
    dpush(lst2cell(l[1..$]));
  else
    dpush(lst2cell(new_lst()));
}

void p_cons()
{
  cell[] l=cell2lst(dpop());
  cell   e=dpop();
  dpush(lst2cell(e~l));
}

void p_split()
{
  cell[] l=cell2lst(dpop());
  if (l.length>0)
    dpush(l[0]);
  if (l.length>1)
    dpush(lst2cell(l[1..$]));
  else
    dpush(lst2cell(new_lst()));
}

void p_scons()
{
  cell   e=dpop();
  cell[] l=cell2lst(dpop());
  dpush(lst2cell(e~l));
}

void p_splits()
{
  cell[] l=cell2lst(dpop());
  if (l.length>1)
    dpush(lst2cell(l[1..$]));
  else
    dpush(lst2cell(new_lst()));
  if (l.length>0)
    dpush(l[0]);
}

void p_length()
{
  dpush(int2cell(cell2lst(dpop()).length));
}

void p_reverse()
{
  dpush_lst(dpop_lst().dup.reverse);
}

