
module grace_prim_math;

import grace_def;
import grace_cstk;
import grace_dict;
import grace_eval;
import grace_reader;
import grace_prim;

void reg_prims_math()
{
  // math, int int
  dict_addnf("-" ,&p_int_int_sub,["int","int"],["int"]);
  dict_addnf("+" ,&p_int_int_add,["int","int"],["int"]);
  dict_addnf("*" ,&p_int_int_mul,["int","int"],["int"]);
  dict_addnf("/" ,&p_int_int_div,["int","int"],["int"]);
  dict_addnf("%" ,&p_int_int_mod,["int","int"],["int"]);
  dict_addnf(">" ,&p_int_int_gt ,["int","int"],["log"]);
  dict_addnf("<" ,&p_int_int_st ,["int","int"],["log"]);
  dict_addnf("=" ,&p_int_int_eq ,["int","int"],["log"]);
  dict_addnf("!=",&p_int_int_ne ,["int","int"],["log"]);
  dict_addnf(">=",&p_int_int_ge ,["int","int"],["log"]);
  dict_addnf("<=",&p_int_int_se ,["int","int"],["log"]);
  // math, int flt
  dict_addnf("-" ,&p_int_flt_sub,["int","flt"],["flt"]);
  dict_addnf("+" ,&p_int_flt_add,["int","flt"],["flt"]);
  dict_addnf("*" ,&p_int_flt_mul,["int","flt"],["flt"]);
  dict_addnf("/" ,&p_int_flt_div,["int","flt"],["flt"]);
  dict_addnf("%" ,&p_int_flt_mod,["int","flt"],["flt"]);
  dict_addnf(">" ,&p_int_flt_gt ,["int","flt"],["log"]);
  dict_addnf("<" ,&p_int_flt_st ,["int","flt"],["log"]);
  dict_addnf("=" ,&p_int_flt_eq ,["int","flt"],["log"]);
  dict_addnf("!=",&p_int_flt_ne ,["int","flt"],["log"]);
  dict_addnf(">=",&p_int_flt_ge ,["int","flt"],["log"]);
  dict_addnf("<=",&p_int_flt_se ,["int","flt"],["log"]);
  // math, flt int
  dict_addnf("-" ,&p_flt_int_sub,["flt","int"],["flt"]);
  dict_addnf("+" ,&p_flt_int_add,["flt","int"],["flt"]);
  dict_addnf("*" ,&p_flt_int_mul,["flt","int"],["flt"]);
  dict_addnf("/" ,&p_flt_int_div,["flt","int"],["flt"]);
  dict_addnf("%" ,&p_flt_int_mod,["flt","int"],["flt"]);
  dict_addnf(">" ,&p_flt_int_gt ,["flt","int"],["log"]);
  dict_addnf("<" ,&p_flt_int_st ,["flt","int"],["log"]);
  dict_addnf("=" ,&p_flt_int_eq ,["flt","int"],["log"]);
  dict_addnf("!=",&p_flt_int_ne ,["flt","int"],["log"]);
  dict_addnf(">=",&p_flt_int_ge ,["flt","int"],["log"]);
  dict_addnf("<=",&p_flt_int_se ,["flt","int"],["log"]);
  // math, flt flt
  dict_addnf("-" ,&p_flt_flt_sub,["flt","flt"],["flt"]);
  dict_addnf("+" ,&p_flt_flt_add,["flt","flt"],["flt"]);
  dict_addnf("*" ,&p_flt_flt_mul,["flt","flt"],["flt"]);
  dict_addnf("/" ,&p_flt_flt_div,["flt","flt"],["flt"]);
  dict_addnf("%" ,&p_flt_flt_mod,["flt","flt"],["flt"]);
  dict_addnf(">" ,&p_flt_flt_gt ,["flt","flt"],["log"]);
  dict_addnf("<" ,&p_flt_flt_st ,["flt","flt"],["log"]);
  dict_addnf("=" ,&p_flt_flt_eq ,["flt","flt"],["log"]);
  dict_addnf("!=",&p_flt_flt_ne ,["flt","flt"],["log"]);
  dict_addnf(">=",&p_flt_flt_ge ,["flt","flt"],["log"]);
  dict_addnf("<=",&p_flt_flt_se ,["flt","flt"],["log"]);
}

static this()
{
  reg_prims~=&reg_prims_math;
}

// --------------------
// ----- math, int int

void p_int_int_add()
{
  cell c=dpop();
  dpush(int2cell(cell2int(dpop())+cell2int(c)));
}

void p_int_int_sub()
{
  // this could be generated code
  int a=dpop_int();
  int b=dpop_int();
  int c;
  c=b-a;
  dpush_int(c);
  /*
  // --- tested: all these are about equal in speed ! ---
  // int vars for everything using cell stack ops and conversion
  int a=cell2int(dpop());
  int b=cell2int(dpop());
  int c=b-a;
  dpush(int2cell(c));
  // int vars for everything using typed stack ops
  int a=dpop_int();
  int b=dpop_int();
  int c=b-a;
  dpush_int(c);
  // cell vars for everything
  cell c=dpop();
  cell d=dpop();
  cell e=int2cell(cell2int(d)-cell2int(c));
  dpush(e);
  // original code
  cell c=dpop();
  dpush(int2cell(cell2int(dpop())-cell2int(c)));
  */
}

void p_int_int_mul()
{
  cell c=dpop();
  dpush(int2cell(cell2int(dpop())*cell2int(c)));
}

void p_int_int_div()
{
  cell c=dpop();
  dpush(int2cell(cell2int(dpop())/cell2int(c)));
}

void p_int_int_mod()
{
  cell c=dpop();
  dpush(int2cell(cell2int(dpop())%cell2int(c)));
}

void p_int_int_gt()
{
  cell c=dpop();
  dpush(log2cell(cell2int(dpop())>cell2int(c)));
}

void p_int_int_st()
{
  cell c=dpop();
  dpush(log2cell(cell2int(dpop())<cell2int(c)));
}

void p_int_int_eq()
{
  cell c=dpop();
  dpush(log2cell(cell2int(dpop())==cell2int(c)));
}

void p_int_int_ne()
{
  cell c=dpop();
  dpush(log2cell(cell2int(dpop())!=cell2int(c)));
}

void p_int_int_ge()
{
  cell c=dpop();
  dpush(log2cell(cell2int(dpop())>=cell2int(c)));
}

void p_int_int_se()
{
  cell c=dpop();
  dpush(log2cell(cell2int(dpop())<=cell2int(c)));
}

// --------------------
// ----- math, int flt

void p_int_flt_add()
{
  cell c=dpop();
  dpush(flt2cell(cell2int(dpop())+cell2flt(c)));
}

void p_int_flt_sub()
{
  cell c=dpop();
  dpush(flt2cell(cell2int(dpop())-cell2flt(c)));
}

void p_int_flt_mul()
{
  cell c=dpop();
  dpush(flt2cell(cell2int(dpop())*cell2flt(c)));
}

void p_int_flt_div()
{
  cell c=dpop();
  dpush(flt2cell(cell2int(dpop())/cell2flt(c)));
}

void p_int_flt_mod()
{
  cell c=dpop();
  dpush(flt2cell(cell2int(dpop())%cell2flt(c)));
}

void p_int_flt_gt()
{
  cell c=dpop();
  dpush(log2cell(cell2int(dpop())>cell2flt(c)));
}

void p_int_flt_st()
{
  cell c=dpop();
  dpush(log2cell(cell2int(dpop())<cell2flt(c)));
}

void p_int_flt_eq()
{
  cell c=dpop();
  dpush(log2cell(cell2int(dpop())==cell2flt(c)));
}

void p_int_flt_ne()
{
  cell c=dpop();
  dpush(log2cell(cell2int(dpop())!=cell2flt(c)));
}

void p_int_flt_ge()
{
  cell c=dpop();
  dpush(log2cell(cell2int(dpop())>=cell2flt(c)));
}

void p_int_flt_se()
{
  cell c=dpop();
  dpush(log2cell(cell2int(dpop())<=cell2flt(c)));
}

// --------------------
// ----- math, flt int

void p_flt_int_add()
{
  cell c=dpop();
  dpush(flt2cell(cell2flt(dpop())+cell2int(c)));
}

void p_flt_int_sub()
{
  cell c=dpop();
  dpush(flt2cell(cell2flt(dpop())-cell2int(c)));
}

void p_flt_int_mul()
{
  cell c=dpop();
  dpush(flt2cell(cell2flt(dpop())*cell2int(c)));
}

void p_flt_int_div()
{
  cell c=dpop();
  dpush(flt2cell(cell2flt(dpop())/cell2int(c)));
}

void p_flt_int_mod()
{
  cell c=dpop();
  dpush(flt2cell(cell2flt(dpop())%cell2int(c)));
}

void p_flt_int_gt()
{
  cell c=dpop();
  dpush(log2cell(cell2flt(dpop())>cell2int(c)));
}

void p_flt_int_st()
{
  cell c=dpop();
  dpush(log2cell(cell2flt(dpop())<cell2int(c)));
}

void p_flt_int_eq()
{
  cell c=dpop();
  dpush(log2cell(cell2flt(dpop())==cell2int(c)));
}

void p_flt_int_ne()
{
  cell c=dpop();
  dpush(log2cell(cell2flt(dpop())!=cell2int(c)));
}

void p_flt_int_ge()
{
  cell c=dpop();
  dpush(log2cell(cell2flt(dpop())>=cell2int(c)));
}

void p_flt_int_se()
{
  cell c=dpop();
  dpush(log2cell(cell2flt(dpop())<=cell2int(c)));
}

// --------------------
// ----- math, flt flt

void p_flt_flt_add()
{
  cell c=dpop();
  dpush(flt2cell(cell2flt(dpop())+cell2flt(c)));
}

void p_flt_flt_sub()
{
  cell c=dpop();
  dpush(flt2cell(cell2flt(dpop())-cell2flt(c)));
}

void p_flt_flt_mul()
{
  cell c=dpop();
  dpush(flt2cell(cell2flt(dpop())*cell2flt(c)));
}

void p_flt_flt_div()
{
  cell c=dpop();
  dpush(flt2cell(cell2flt(dpop())/cell2flt(c)));
}

void p_flt_flt_mod()
{
  cell c=dpop();
  dpush(flt2cell(cell2flt(dpop())%cell2flt(c)));
}

void p_flt_flt_gt()
{
  cell c=dpop();
  dpush(log2cell(cell2flt(dpop())>cell2flt(c)));
}

void p_flt_flt_st()
{
  cell c=dpop();
  dpush(log2cell(cell2flt(dpop())<cell2flt(c)));
}

void p_flt_flt_eq()
{
  cell c=dpop();
  dpush(log2cell(cell2flt(dpop())==cell2flt(c)));
}

void p_flt_flt_ne()
{
  cell c=dpop();
  dpush(log2cell(cell2flt(dpop())!=cell2flt(c)));
}

void p_flt_flt_ge()
{
  cell c=dpop();
  dpush(log2cell(cell2flt(dpop())>=cell2flt(c)));
}

void p_flt_flt_se()
{
  cell c=dpop();
  dpush(log2cell(cell2flt(dpop())<=cell2flt(c)));
}

