
public import std.c.stdlib;
public import std.c.string;
public import std.utf;
public import std.conv;
public import std.file;
public import std.stdio;
public import std.boxer;
public import std.format;
public import std.string;
public import std.regexp;

const int CT_INT =  1; // integer
const int CT_FLT =  2; // float
const int CT_SYM =  3; // symbol
const int CT_STR =  4; // string
const int CT_HDR =  5; // header
const int CT_LST =  6; // list
const int CT_PTR =  7; // pointer
const int CT_NFP =  8; // native function pointer
const int CT_LOG =  9; // logical
const int CT_REX = 10; // regular expression
const int CT_BAR = 11; // byte array
const int CT_ASA = 12; // associative array
const int CT_CEL = 13; // associative array

struct type
{
  char[]  nam;
  type[]  sub;
}

void pr(type t,int r=0)
{
  if (t.sub.length)
  {
    writef(t.nam,":[ ");
    for (int k=0;k<t.sub.length;k++)
      pr(t.sub[k],r+1);
    writef("] ");
  }
  else
  {
    writef(t.nam," ");
  }
  if (!r)
    writef("\n");
}

type as2typ(inout char[][] as)
{
  type t;
  if (as.length==0)
    return t;
  if (as.length==1)
  {
    t.nam=as[0];
    return t;
  }
  t.nam="lst";
  while (as.length>0)
  {
    writefln(as.length,":",as,":",as[0]);
    if (as[0]==",")
    {
      as=as[1..$];
    }
    else if (as[0]=="[")
    {
      as=as[1..$];
      t.sub~=as2typ(as);
    }
    else if (as[0]=="]")
    {
      as=as[1..$];
      return t;
    }
    else
    {
      type h;
      h.nam=as[0];
      t.sub~=h;
      as=as[1..$];
    }
  }
  return t;
}

type str2typ(char[] s)
{
  type t;
  s=std.regexp.sub(s,"[,]"," ","g");
  s=std.regexp.sub(s,"[][*+?/-;]"," $& ","g");
  s=std.regexp.sub(s,r"\s+","%","g");
  s=std.regexp.sub(s,r"^%","");
  s=std.regexp.sub(s,r"%$","");
  char[][] as=std.regexp.split(s,r"%");
  t=as2typ(as);
  return t;
}

/*
  declaration-string
  ------------------
  
  id:type_list/type_list-type_list/type_list;

  type-string
  -----------

  ?
    any type
    
  lst
    list with anything in it

  [int,flt]
    list with one int and one flt
    
  [int*]
    list of 0+ ints

  [flt+]
    list of 1+ floats
*/

void main()
{
  type t;
  t=str2typ("int,[flt,flt],lst,flt");
  pr(t);
}
