/*
 * MyDll demonstration of how to write D DLLs.
 */

import std.c.stdio;
import std.c.stdlib;
import std.string;
import std.c.windows.windows;
import std.gc;

HINSTANCE   g_hInst;

struct cell
{
  union
  {
    int      i;
    float    f;
//    nfun     n;
    void    *p;
//    header  *h;
    char[]  *s;
//    Box     *b;
//    symbol  *y;
  };
  int    th; // type hash
}

cell[] *stk;

struct iniStruct
{
  void   *gc;
  void   *reg;
  cell[] *stk;
}

extern (C)
{
  void _minit();
  void _moduleCtor();
  void _moduleDtor();
  void _moduleUnitTests();
}

extern (Windows)

BOOL DllMain(HINSTANCE hInstance, ULONG ulReason, LPVOID pvReserved)
{
  switch (ulReason)
  {
    case DLL_PROCESS_ATTACH:
      printf("DLL_PROCESS_ATTACH\n");
      break;
    case DLL_PROCESS_DETACH:
      printf("DLL_PROCESS_DETACH\n");
      std.c.stdio._fcloseallp = null; // so stdio doesn't get closed
      break;
    case DLL_THREAD_ATTACH:
      printf("DLL_THREAD_ATTACH\n");
      return false;
    case DLL_THREAD_DETACH:
      printf("DLL_THREAD_DETACH\n");
      return false;
  }
  g_hInst = hInstance;
  return true;
}

export void MyDLL_Initialize(void* p)
{
  iniStruct *inst=cast(iniStruct*)p;

  printf("MyDLL_Initialize()\n");
  std.gc.setGCHandle(inst.gc);
  _minit();
  _moduleCtor();
  stk=inst.stk;
  reg_prims(inst.reg);
//  _moduleUnitTests();
}

export void MyDLL_Terminate()
{
  printf("MyDLL_Terminate()\n");
  _moduleDtor();// run module destructors
  std.gc.endGCHandle();
}

static this()
{
  printf("static this for mydll\n");
}

static ~this()
{
  printf("static ~this for mydll\n");
}

extern (D)

/* --------------------------------------------------------- */

const int FLG_F = 1;
const int FLG_M = 2;

alias void function(char[],void*,int,char[][],char[][]) dict_addn_fp;

void reg_prims(void* fp)
{
  dict_addn_fp dict_addn=(cast(dict_addn_fp)fp);
  printf("adding job2...");
  printf("%p...",fp);
  dict_addn("sub",cast(void*)(&job2),FLG_F,["int","int"],["int"]);
  printf("okay!\n");
}

void job2()
{
  (*stk)[$-2].i=(*stk)[$-2].i-(*stk)[$-1].i;
  (*stk).length=(*stk).length-1;
//  (*cast(cell[]*)(*stk)).length=(*cast(cell[]*)(*stk)).length-1;
}
